
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>UVa 10125 - Sumsets / 憋错料</title>

    <meta name="description" content="UVa 10125 - Sumsets 题目:给你n个数让你在里面找到会不相同的4个数a,b,c,d,使得 d = a + b + c. 分析:数学题,散列表.这是一个优化问题. 方法1:暴力法: 先排序,然后直接利用四层循环求解,找到解后直接跳出,也可以以利用二分代替最后一层循环: 这种方法,如果遇到特殊的数据就会TLE: 方法2:分步计算: 将等式转化为 d - a = b + c:我们分别求解两边的结果,然后找到结果相同的值即可: 查找方法,可以使用散列表储存b + c 或 a + b 的值,供另一边查找:也可存进数组,二分查找">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">UVa 10125 - Sumsets</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>题目：给你n个数让你在里面找到会不相同的4个数a，b，c，d，使得 d = a &#043; b &#043; c。</p>
<p>分析：数学题，散列表。这是一个优化问题。</p>
<p>方法1：暴力法；</p>
<p>先排序，然后直接利用四层循环求解，找到解后直接跳出，也可以以利用二分代替最后一层循环；</p>
<p>这种方法，如果遇到特殊的数据就会TLE；</p>
<p>方法2：分步计算；</p>
<p>将等式转化为 d - a = b &#043; c；我们分别求解两边的结果，然后找到结果相同的&#20540;即可；</p>
<p>查找方法，可以使用散列表储存b &#043; c 或 a &#043; b 的&#20540;，供另一边查找；也可存进数组，二分查找。</p>
<p>说明：存储时记录计算的两个元素的下标，每个数字都不同；注意哈希&#20540;可能为负。</p>
<pre>#include &lt;algorithm&gt;
#include &lt;iostream&gt;
#include &lt;cstdlib&gt;
#include &lt;cstring&gt;
#include &lt;cstdio&gt;
#include &lt;cmath&gt;

using namespace std;

/* Hash define */
#define nodesize 500000
#define hashsize 1000  

typedef struct node
{
    int  value,l,r;
    node* next;
}list;
list  dict[nodesize+1];
list* head[hashsize+1];

class Hash
{
    private:
        int size;
    public:
        Hash(){size = 0;memset( head, 0, sizeof(head) );}
        int hash( int value ) {return abs(value)%hashsize;}
        void insert( int value, int i, int j ) {
            int id = hash(value);
            dict[size].value = value;
            dict[size].l = i;
            dict[size].r = j;
            dict[size].next = head[id];
            head[id] = &amp;dict[size ++];
        }
        int find( int value, int i, int j ) {
            int id = hash(value);
            for ( list* p = head[id] ; p ; p = p-&gt;next )
                if ( value == p-&gt;value )
				if ( i != p-&gt;r &amp;&amp; i != p-&gt;l &amp;&amp; j &lt; p-&gt;l )
					return true;
            return false;
        }
};
/* Hash end */  

int data[1002];

int main()
{
	int n;
	while ( cin &gt;&gt; n &amp;&amp; n ) {
		for ( int i = 1 ; i &lt;= n ; ++ i )
			cin &gt;&gt; data[i];
		sort( data+1, data+n+1 );

		Hash hash;
		for ( int i = 1 ; i &lt;= n ; ++ i )
		for ( int j = i+1 ; j &lt;= n ; ++ j )
			hash.insert( data[i]+data[j], i, j );
		int flag = 0;
		for ( int i = n ; i &gt;= 1 ; -- i ) {
			for ( int j = 1 ; j &lt;= n ; ++ j )
				if ( i != j &amp;&amp; hash.find( data[i]-data[j], i, j ) ) {
					cout &lt;&lt; data[i] &lt;&lt; endl;
					flag = 1; break;
				}
			if ( flag ) break;
		}

		if ( !flag ) cout &lt;&lt; &quot;no solution&quot; &lt;&lt; endl;
	}
	return 0;
}
</pre>
<p><P>UVa 10125 - Sumsets</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 12:47:27 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.biecuoliao.com/tag/2014/" title="2014">2014</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>UVa 10125 - Sumsets的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vQz9X0.html" rel="bookmark">uva 10125 - Sumsets&lpar;a&plus;b&plus;c&equals;d&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				希望下次能马上想到 a+b .d-c 分开来算.然后保存其中一项的值,算出另一项来就查找该值是否存在. 这种方法明显比三重循环省时. 还有下面的方法: 三重循环穷举a,b,d;然后二分穷举c: #include&lt;stdio.h&gt; #include&lt;algorithm&gt; #include&lt;string.h&gt; using namespace std; int a[1010],i,j,k,ans,f,n; int comp(int x,int y) { return x&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Ny5xy3.html" rel="bookmark">uva 10125和集 sumset（set）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				给定数字集合,找出最大的d,使得a+b+c=d且abc均在数字集合中,集合元素数量不超过1000 思路是把等式变换为d-c=a+b,这样只要枚举d,c,验证d-c是否在任意两元素之和所在的集合中,注意abcd不能重复,所以需要一些额外的判重条件 #include&lt;cstdio&gt; #include&lt;cstring&gt; #include&lt;cmath&gt; #include&lt;cstdlib&gt; #include&lt;iostream&gt; #include&lt;al			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n6VNX0.html" rel="bookmark">【HASH】【UVA 10125】 Sumset</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				传送门 Description 给定一个整数集合S,求一个最大的d,满足a+b+c=d,其中a,b,c,d∈S Input 多组数据,每组数据包括: 第一行一个整数n,代表元素个数 下面n行每行一个整数,代表集合元素 输入结束的标志为n=0. Output 对于每组数据,输出: 一行,如果有解,输出一个整数,代表最大的d:否则输出no solution Sample Input 5 2 3 5 7 12 5 2 16 64 256 1024 0 Sample Output 12 no solut			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KONjw0.html" rel="bookmark">UVA题目分类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目 Volume 0. Getting Started 开始10055 - Hashmat the Brave Warrior 10071 - Back to High School Physics 10300 - Ecological Premium 458 - The Decoder 494 - Kindergarten Counting Game 414 - Machined Surfaces 490 - Rotating Sentences 445 - Marvelous Mazes			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/k0eVg3r.html" rel="bookmark">UVA 562 Dividing coins --01背包的变形</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				01背包的变形. 先算出硬币面值的总和,然后此题变成求背包容量为V=sum/2时,能装的最多的硬币,然后将剩余的面值和它相减取一个绝对值就是最小的差值. 代码: #include &lt;iostream&gt; #include &lt;cstdio&gt; #include &lt;cstring&gt; #include &lt;cmath&gt; #include &lt;algorithm&gt; using namespace std; #define N 50007 int c[102],d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/138Oy0A.html" rel="bookmark">UVA 10341 Solve It</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Problem F Solve It Input: standard input Output: standard output Time Limit: 1 second Memory Limit: 32 MB Solve the equation: p*e-x + q*sin(x) + r*cos(x) + s*tan(x) + t*x2 + u = 0 where 0 &lt;= x &lt;= 1. Input Input consists of multiple test cases and te			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/P47pDRM.html" rel="bookmark">UVA 11014 - Make a Crystal&lpar;容斥原理&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UVA 11014 - Make a Crystal 题目链接 题意:给定一个NxNxN的正方体,求出最多能选几个整数点.使得随意两点PQ不会使PQO共线. 思路:利用容斥原理,设f(k)为点(x, y, z)三点都为k的倍数的点的个数(要扣掉一个原点O).那么全部点就是f(1),之后要去除掉共线的,就是扣掉f(2), f(3), f(5)..f(n).n为素数.由于这些素数中包括了合数的情况,而且这些点必定与f(1)除去这些点以外的点共线,所以扣掉.可是扣掉后会扣掉一些反复的.比方f(6)在f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q0x5Jk3.html" rel="bookmark">&lbrack;UVa&rsqb; Palindromes&lpar;401&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UVA - 401 Palindromes Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld &amp; %llu Submit Status Description A regular palindrome is a string of numbers or letters that is the same forward as backward. For example, the string &quot;ABCDED			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MEvNP0.html" rel="bookmark">uva 401&period;Palindromes</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:https://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_problem&amp;problem=342 题目意思:给出一段字符串(大写字母+数字组成).判断是否为回文串 or 镜像串 or 回文镜像串 or 什么都不是.每个字母的镜像表格如下 Character Reverse Character Reverse Character Reverse A A M M Y Y B			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vP9kM.html" rel="bookmark" class="title">四边形优化DP学习</a>
					<div>
						转自:http://www.cnblogs.com/hadilo/p/5800306.html 在动态规划中,经常遇到形如下式的状态转移方程: m(i,j)=min{m(i,k-1),m(k,j)}+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyaJYM.html" rel="bookmark" class="title">oracle新加实例</a>
					<div>
						[[email protected]_NORMAL2_DB ~]$ dbca  --oracle用户下执行这个命令,会出来图形化界面 直接finish即完成实例的创建 下面是修改配置文件 在只有一个实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knQLjM.html" rel="bookmark" class="title">Android总结篇系列：Activity Intent Flags及Task相关属性</a>
					<div>
						同上文一样,本文主要引用自网上现有博文,并加上一些自己的理解,在此感谢原作者. 原文地址: http://blog.csdn.net/liuhe688/article/details/6761337  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAQj50.html" rel="bookmark" class="title">对接口编程：接口和抽象类</a>
					<div>
						在&lt;大话设计模式&gt;这本书中,我会听到这个字眼&quot;对接口编程&quot;,而在文中的类图中,会提出这样一个疑问?为什么有的用的是:接口?有的用的是抽象类呢? 本文主要介绍以下内容:接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Z1PWM.html" rel="bookmark" class="title">在Unity3D中实现高效的战斗飘字</a>
					<div>
						版权所有,转载须注明出处!喜欢火影.喜欢Java.喜欢unity3D.喜欢游戏开发的都可以加入木叶村Q群:379076227 这周有网友提到用NGUI做战斗冒血,冒伤害等文字性能太差.确实如此,我之前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZxln3.html" rel="bookmark" class="title">【LeetCode】36 - Valid Sudoku</a>
					<div>
						Determine if a Sudoku is valid, according to: Sudoku Puzzles - The Rules.(http://sudoku.com.au/TheRu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjOYE3.html" rel="bookmark" class="title">cocos2d-x场景效果切换</a>
					<div>
						Cocos2d-x提供了很多场景间切换的效果 1.使用方法: ccTime t = 1.2;    CCScene * pScene = CCScene::node();    CCLayer *pL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZVZx0.html" rel="bookmark" class="title">JAVA优先级队列测试</a>
					<div>
						package code.test; import java.util.Comparator; import java.util.Iterator; import java.util.Priority ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7v9X4.html" rel="bookmark" class="title">IntelliJ IDEA快捷键</a>
					<div>
						跳转: Ctrl+Home/End,光标中跳转到第一行或最后一行下 Ctrl+B/Ctrl+Click,快速打开光标处的类或方法(跳转到定义处) Ctrl+Alt+B,跳转到方法实现处 Ctrl+Sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022qgo0.html" rel="bookmark" class="title">IaaS中的统一存储：从设计到实现</a>
					<div>
						转自:https://www.ustack.com/blog/tycc/ &quot;原生的OpenStack并不支持统一存储,云主机服务Nova.镜像服务Glance.云硬盘服务Cinder的后端存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxBlZ3.html" rel="bookmark" class="title">C&num;之使用随机数</a>
					<div>
						1.C#自带随机数函数 using System; System.Random ran = new System.Random();int n = ran.Next(100, 1000);//产生10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqbvz0.html" rel="bookmark" class="title">javascript获取ckeditor编辑器的值&lpar;实现代码&rpar;</a>
					<div>
						CKeditor编辑器是FCKeditor的升级版本想对于FCK来说,确实比较好用,加载速度也比较快以下是如果通过JS获取CKeditor编辑器的值,用于表单验证 if(CKEDITOR.instan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49lBvA3.html" rel="bookmark" class="title">如何理解java中的回调</a>
					<div>
						以android中的Button的setOnClickListener这个回调为例: Button button = (Button)this.findViewById(R.id.button); b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q81270.html" rel="bookmark" class="title">数据库设计的必要性</a>
					<div>
						为什么要对数据库进行设计? 当我们要存储的数据比较少的是后当然不需要对数据库进行设计,但是当我们对数据的需求量越来越大时对数据库的设计就很有必要性了!如果数据库的设计不当会造成数据冗余.修改复杂.操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q8BA90.html" rel="bookmark" class="title">VS2010&sol;MFC编程入门之五（MFC消息映射机制概述）</a>
					<div>
						VS2010/MFC编程入门之五(MFC消息映射机制概述)-软件开发-鸡啄米 http://www.jizhuomi.com/software/147.html     上一讲鸡啄米为大家简单分析了M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dDq5e0.html" rel="bookmark" class="title">jquery1&period;2以上    待url载入文件地址  成功载入后回调函数</a>
					<div>
						jQuery.getScript('url',function(){}) jquery1.2以上    待url载入文件地址  成功载入后回调函数 $.getScript('test.js') 加载并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6nlXvM.html" rel="bookmark" class="title">JS访问或设置cookie的方法&plus;跨域调用方法</a>
					<div>
						无意中从163网站获取的JS访问或设置cookie的方法,Log到日志上以防遗忘 //COOKIE功能检查function fCheckCookie(){    if(!navigator.cooki ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nwRno3.html" rel="bookmark" class="title">2014025637（11）《嵌入式程序设计》第二周总结</a>
					<div>
						在第二周,我学习了一些技术,在实验楼学习了新的技术,但是上课老师已经教了,我学的不是很明白,就在实验楼再学一遍 一.GCC常用编译选项解析常用编译选项 (1)-E:只对文件进行预处理. (2)-S:只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OkAQX3.html" rel="bookmark" class="title">解决UIScrollView中添加子控件出现&OpenCurlyDoubleQuote;UIScrollView Scrollable Content Size Ambiguity&rdquo;的办法</a>
					<div>
						来自StackOverflow的帖子,原文见这里. So I just sorted out in this way: Add in the UIScrollView a UIView (we can ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX1Kv80.html" rel="bookmark" class="title">更改窗体皮肤</a>
					<div>
						第一步 先把IrisSkin2.dll文件[添加到当前项目引用(解决方案资源管理器-&gt;当前项目-&gt;引用-&gt;右键-&gt;添加引用,找到IrisSkin2.dll文件 IrisSkin ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
